// https://codeforces.com/problemset/problem/161/D
// 0.374 s
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

typedef vector<bool> VB;
typedef vector<int> VI;
typedef vector<VI> VVI;
typedef vector<vector<unsigned short>> VVUS;
VB v;
VVUS G;
unsigned short n, K;
int res;

void Read();
VI Df(int x); // ret nr de lanturi care au capatul de sus in x

int main()
{
	Read();
	Df(1);
	cout << res;
}

void Read()
{
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> K;
	G = vector<vector<unsigned short>>(n + 1);
	v = VB(n + 1);
	int x, y;
	for (int i = 0; i < n - 1; ++i)
	{
		cin >> x >> y;
		G[x].push_back(y);
		G[y].push_back(x);
	}
}

VI Df(int x)
{
	v[x] = true;
	VI X(K + 1); // X[i] - nr lanturi de lung i care coboara din x (capatul de sus in x)
	X[0] = 1;    // Intr-un singur mod se poate avea un lant de lungime 0 care coboara din x
	
	for (const unsigned short& f : G[x])
	{
		if (v[f]) continue;
		
		VI F = Df(f);
		for (int i = 0; i <= K - 1; ++i) // Nu ma intereseaza decat lanturile de lungime K
			res += X[i] * F[K - i - 1];  // care au intermediar pe x (si nu urca spre tata lui x)		
	
		for (int i = 1; i <= K; ++i)     // Acum lanturilor care coboara din x li se adauga cele care coboara din fiu
			X[i] += F[i - 1];            // scad muchia de legatura
	}

	return X;
}

